#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include "common.h"
#include "log.h"
#include "recdb.h"

dict_t enc_passwords;

void
log(enum log_type lt, enum log_severity ls, char *format, ...)
{
    (void)lt; (void)ls; (void)format;
    /* this just makes the link work fine */
}

static int
check_password(const char *key, void *data, void *extra)
{
    struct record_data *rd = data;
    dict_t user_db;
    char *hashed, *misc, *found, *badness, enc_handle[MD5_CRYPT_LENGTH];
    (void)extra;

    if (!(user_db = GET_RECORD_OBJECT(rd))) return 0;
    hashed = database_get_data(user_db, "passwd", RECDB_QSTRING);
    if (!hashed) return 0;
    if ((found = dict_find(enc_passwords, hashed, 0))) {
        /* found == dictionary word */
    } else if (!strcmp(hashed, cryptpass(key, enc_handle))) {
        found = (char*)key;
    }
    if (!found) return 0;
    badness = "";
    if ((misc = database_get_data(user_db, "flags", RECDB_QSTRING))) {
        if (strchr(misc, 'g') || strchr(misc, 'h')) badness = "VERY ";
    } else if ((misc = database_get_data(user_db, "opserv_level", RECDB_QSTRING))) {
        badness = "VERY ";
    }
    fprintf(stdout, "%sBAD %s: using \"%s\"\n", badness, key, found);
    return 0;
}

int
main(int argc, char *argv[])
{
    FILE *wordfile;
    dict_t dict;
    char *word, enc[MD5_CRYPT_LENGTH];

    if (argc < 2) {
        fprintf(stdout, "USAGE: %s nickserv.db\n", argv[0]);
        return 1;
    }
    enc_passwords = dict_new();
    if (argc > 2) {
        char line[128];
        if (!(wordfile = fopen(argv[2], "r"))) {
            fprintf(stdout, "Unable to open wordfile %s\n", argv[2]);
            return 3;
        }
        while (!feof(wordfile)) {
            fgets(line, sizeof(line), wordfile);
            if (!line[0]) continue;
            if (line[strlen(line)-1] == '\n') line[strlen(line)-1] = 0;
            dict_insert(enc_passwords, strdup(cryptpass(line, enc)), strdup(line));
        }
        fclose(wordfile);
        fprintf(stdout, "%d words preloaded to encrypted password dict\n", dict_size(enc_passwords));
    }
    word = "password";
    dict_insert(enc_passwords, strdup(cryptpass(word, enc)), strdup(word));
    word = "<password>";
    dict_insert(enc_passwords, strdup(cryptpass(word, enc)), strdup(word));
    dict = parse_database(argv[1]);
    if (!dict) {
        fprintf(stdout, "Unable to read database %s\n", argv[1]);
        return 2;
    }
    dict_foreach(dict, check_password, 0);
    return 0;
}
